string CheckFilter()
  {
   // Erstelle einen String fuer das Signal
   // create a string for the signal
   string signal="";
   
   // Erstelle ein Array
   // Create an Array
   MqlRates PriceInformation[];  
   
   // Sortiere es von der aktuellen Kerze an abwaerts
   // Sort it from current candle to oldest candle
   ArraySetAsSeries(PriceInformation,true); 
   
   // Kopiere die Preisdaten in das Array
   // Copy price data into the array
   int Data=CopyRates(_Symbol,_Period,0,3,PriceInformation);
   
   // Erstelle ein Array fuer die EA Daten
   // create an Array for the EA data
   double UpperBandArray[];
   double LowerBandArray[];
   
   // Sortiere die Preisdaten von der aktuellen Kerze an abwaerts
   // sort the price array from the current candle downwards
   ArraySetAsSeries(UpperBandArray,true); 
   ArraySetAsSeries(LowerBandArray,true);   
   
   // Definiere den Envelopes EA
   // define Envelopes EA
   int EnvelopesDefinition=iEnvelopes(_Symbol,_Period,14,0,MODE_SMA,PRICE_CLOSE,0.100);
   
   // Kopiere die Preisinformationen in das Array
   // Copy price info into the array
   CopyBuffer(EnvelopesDefinition,0,0,3,UpperBandArray);
   CopyBuffer(EnvelopesDefinition,1,0,3,LowerBandArray); 
   
   // Berechne EA fuer die aktuelle Kerze
   // calculate EA for the current candle
   double myUpperBandValue=NormalizeDouble(UpperBandArray[0],6);
   double myLowerBandValue=NormalizeDouble(LowerBandArray[0],6);   
   
   // Chart Ausgabe fuer den aktuellen EA
   // Chart output of the current EA
   
   // Wenn die letzte Kerze unter dem unteren Band geschlossen wurde
   // if the last candle closed below lower band   
   if (PriceInformation[1].close < myLowerBandValue) 
   signal="buy";   

  // Wenn die letzte Kerze ueber dem oberen Band geschlossen wurde   
  // if the last candle closed above the upper band
   if (PriceInformation[1].close > myUpperBandValue) 
   signal="sell";  
  
  // if the last candle closed between the bands
   if ((PriceInformation[1].close < myUpperBandValue) &&   
      (PriceInformation[1].close > myLowerBandValue)) 
      signal="";

   // Liefere das Signal an das Hauptmodul zurueck		
   // return signal to main module
   return signal;
  }


 