#property version   "RobotTradingSystem 2024 Christmas"
// Import the system components / Import der System Komponenten
#import "RobotTradingSystemLibrary-2024-Christmas.ex5"
bool GetNewChartCandle();
int GetNumberOfPositionsThisSymbol();
double GetCurrencyPairProfit();
void OpenStopLossBuyTrade(int StopLossPoints);
void OpenStopLossSellTrade(int StopLossPoints);
double SetEquityStop();
int SetMaxPositionsThisSymbol();
double SetPositionSize();
void CloseAllPositions();
double GetHighestSellPositionPrice();
double GetLowestBuyPositionPrice();
void CheckForTick(string signal,string signal2,double InitialEquity,double RiskPercentage,int SL_Points,double TP_Multiplicator, int TP_PositionPoints,double BreakevenStopLevel,double MaxAccountRisk,double PositionSizeMultiplier,double CurveValue, int BigSMA,int SmallSMA,int CrossoverDistance,string LastTradeBeforeStopping, bool NewCandleOverride);
#import

// Import entry logic / Import der Eingangslogik

     #include "CheckEntry_WPR.mq5";  
//   #include "CheckEntry_Stochastic.mq5";
//   #include "CheckEntry_SAR.mq5"; 
//   #include "CheckEntry_CCI.mq5";
//   #include "CheckEntry_IAC.mq5"; 
//   #include "CheckEntry_IAO.mq5";
//   #include "CheckEntry_AdvancedMA.mq5"
//   #include "CheckEntry_BollingerBands.mq5";
//   #include "CheckEntry_MacD.mq5";
//   #include "CheckEntry_Random.mq5";
//   #include "CheckEntry_Envelopes.mq5";
//   #include "CheckEntry_SMA.mq5";
//   #include "CheckEntry_IVIDYA.mq5";
//   #include "CheckEntry_RVI.mq5";
//   #include "CheckEntry_RSI.mq5";
//   #include "CheckEntry_Chaikin.mq5";
//   #include "CheckEntry_BearsPower.mq5";
//   #include "CheckEntry_BullsPower.mq5";
//   #include "CheckEntry_Momentum.mq5";
//   #include "CheckEntry_ITRIX.mq5";
//   #include "CheckEntry_IFORCE.mq5";     
//   #include "CheckEntry_AverageTrueRange.mq5";  
    

double InitialEquity;
double Balance, Equity;
static double InitialBuyPrice=0;
static double InitialSellPrice=0;
      int RNDVALUE=100;
input double RiskPercentage=100
; // Trading Risk 1=low/niedrig 100=high/hoch
input int SL_Points=50000; //Stop Loss Points
input double TP_Multiplicator=5; // Profit Multiplicator (CloseAllPositions)
input double TP_PositionPoints=1; // Profit Divider (PositionTakeProfit)
      double BreakevenStopLevel=1; // Breakeven=Activate Equity Stop
input double MaxAccountRisk=0.10; // MaxAccountRisk
      input double PositionSizeMultiplier=0.1; // Multiplier for Position Size
      input double CurveValue=3;//CurveValue 
      int BigSMA=1100; // Big SMA
      int SmallSMA=1000; // Small SMA
      input int CrossoverDistance=250; // Crossover Distance from SMAs
      input string LastTradeBeforeStopping="no";//yes for the last trade series
input bool NewCandleOverride=false; // true to override for each tick

void OnInit()

{

   // Get Initial Equity
   InitialEquity=AccountInfoDouble(ACCOUNT_EQUITY);

   // Set Object Properties for a Label
   ObjectCreate(0,"Label1", OBJ_LABEL, 0, 0, 0);
   
   // Set Object Font
   ObjectSetString(0,"Label1",OBJPROP_FONT,"Verdana");
   
   // Set Font Size
   ObjectSetInteger(0,"Label1",OBJPROP_FONTSIZE,10); 
   
   // Set Font Size
   ObjectSetInteger(0,"Label1",OBJPROP_COLOR,clrMagenta);    
   
   // Set distance from left border
   ObjectSetInteger(0,"Label1", OBJPROP_XDISTANCE, 2);
   
   // Set corner
   ObjectSetInteger(0,"Label1", OBJPROP_CORNER, 1);   
   
   // Set distance from upper border
   ObjectSetInteger(0,"Label1", OBJPROP_YDISTANCE, 20);
}

void OnTick()
  {
    // Calculate the Balance
    Balance=AccountInfoDouble(ACCOUNT_BALANCE);

    // Calculate the Equity
    Equity=AccountInfoDouble(ACCOUNT_EQUITY);

   // Set Label Text
   ObjectSetString(0,"Label1",OBJPROP_TEXT,0,"ROBOTRADINGSYSTEM.COM EQUITY: "+DoubleToString(Equity)+ " Balance: "+DoubleToString(Balance));        
    
    // check for an entry / Checke Einstieg
    string signal=CheckEntry();    
    
    // check for an entry / Checke Einstieg
    string signal2=signal;   
    
    // call trade management / Rufe Trade Mangement auf
    CheckForTick(signal,signal2,InitialEquity,RiskPercentage,SL_Points,TP_Multiplicator,TP_PositionPoints,BreakevenStopLevel,MaxAccountRisk,PositionSizeMultiplier,CurveValue,BigSMA,SmallSMA,CrossoverDistance,LastTradeBeforeStopping,NewCandleOverride);
    
    
  }
  
   void OnChartEvent(const int id,         // Event ID  
                  const long& lparam,   // Event parameter vom Typ long
                  const double& dparam, // Event parameter vom Typ double
                  const string& sparam  // Event parameter vom Typ string
                 )
  {
   // if mouse was clicked
   if(id==CHARTEVENT_CLICK)
   
   // if click was in upper left corner
   if (lparam <200 && dparam<200)
     {
     Print ("Left upper chart corner was clicked");
      int closeAllPositions=MessageBox("WOULD YOU LIKE TO CLOSE ALL POSITIONS??? ","CLOSE POSITIONS?",MB_YESNO);
      if (closeAllPositions==6) CloseAllPositions();
     }

  }
